﻿using System;
using System.Linq;
using System.Xml;
using System.Collections.Generic;
using UnityEngine;

public static class GameStageFixMethod
{
    public static int GetGameStage(EntityPlayer entityPlayer,byte gamestagemode)
    {
        switch (gamestagemode)
        {
            case 1://new calculation
                {
                    float aliveDay = (float)(entityPlayer.world.worldTime - entityPlayer.gameStageLifetimeTicks) / 24000UL;
                    int aliveDayInt = Mathf.FloorToInt(aliveDay);
                    //difficulty is not used
                    float k = 0f;
                    if (aliveDayInt <= 7)
                    {
                        k = 50f;
                    }
                    else if (aliveDayInt <= 14)
                    {
                        k = 70f;
                    }
                    else if (aliveDayInt <= 21)
                    {
                        k = 110f;
                    }
                    else if (aliveDayInt <= 28)
                    {
                        k = 170f;
                    }
                    else if (aliveDayInt <= 35)
                    {
                        k = 230f;
                    }
                    else
                    {
                        k = 310f;
                    }
                    int aliveDayCalc = Mathf.FloorToInt(aliveDay * k * global::GameStageDefinition.DaysAliveDifficultyBonus);
                    int subNumMax = Mathf.Min(50, aliveDayCalc + 1);
                    int subNum;
                    if (subNumMax != 0 && subNumMax != 1)
                    {
                        subNum = (int)(entityPlayer.Level + entityPlayer.KilledZombies + entityPlayer.totalItemsCrafted + entityPlayer.ExpToNextLevel) % subNumMax;
                    }
                    else
                    {
                        subNum = 0;
                    }
                    return (aliveDayCalc - subNum) + 1;
                }
            case 0://normal calculation
            default:
                {
                    float num = (entityPlayer.world.worldTime - entityPlayer.gameStageLifetimeTicks) / 24000UL;
                    float num2 = (float)entityPlayer.Level;
                    int num3 = Mathf.Clamp(global::GameStats.GetInt(global::EnumGameStats.GameDifficulty), 0, global::GameStageDefinition.GameDifficultyBonus.Length - 1);
                    float num4 = global::GameStageDefinition.GameDifficultyBonus[num3];
                    return Mathf.FloorToInt(num2 * (1f + num * global::GameStageDefinition.DaysAliveDifficultyBonus + num4));

                }
        }
    }
   
    public static void SetAddAttribute(XmlElement element, ref byte gamestagemode)
    {
        if (element.HasAttribute("GameStageMode"))
        {
            gamestagemode = byte.Parse(element.GetAttribute("GameStageMode"));
        }
        else
        {
            gamestagemode = 0;
        }
    }

}
